/*
   eeeee    e     e   eeeeee    eeeeeee    eeeee
  e     e   e     e   e     e   e         e     e
  e         e     e   e     e   e         e
  e         e     e   eeeeee    eeeee      eeeee
  e         e     e   e     e   e               e
  e     e   e     e   e     e   e         e     e
   eeeee     eeeee    eeeeee    eeeeeee    eeeee

   nouveau : Sun 08 Jan 2023 10:15:15 PM CET

*/

/*    ============================================================    */

#declare Sz_cube =	0.87;

/*    ============================================================    */
//
// nouveau valensole 11 juillet 2021

#declare Coins_Cube = object
{
#local P = Sz_cube;
#local D = Sz_cube * 0.102;
union  {
	sphere { 0, D translate <-P, -P, -P> }
	sphere { 0, D translate < P, -P, -P> }
	sphere { 0, D translate <-P,  P, -P> }
	sphere { 0, D translate < P,  P, -P> }

	sphere { 0, D translate <-P, -P,  P> }
	sphere { 0, D translate < P, -P,  P> }
	sphere { 0, D translate <-P,  P,  P> }
	sphere { 0, D translate < P,  P,  P> }
	}
}

#declare Barres_Cube = object
{
#local D2 = Sz_cube * 0.058;
union	{
	/* les verticales */
	cylinder { <-P, -P, -P>, <-P,  P, -P>, D2 }
	cylinder { < P, -P, -P>, < P,  P, -P>, D2 }
	cylinder { <-P, -P,  P>, <-P,  P,  P>, D2 }
	cylinder { < P, -P,  P>, < P,  P,  P>, D2 }

	/* celles d'en haut */
	cylinder { <-P,  P, -P>, <-P,  P,  P>, D2 }
	cylinder { < P,  P, -P>, < P,  P,  P>, D2 }
	cylinder { <-P,  P, -P>, < P,  P, -P>, D2 }
	cylinder { <-P,  P,  P>, < P,  P,  P>, D2 }

	/* celles d'en bas */
	cylinder { <-P, -P, -P>, <-P, -P,  P>, D2 }
	cylinder { < P, -P, -P>, < P, -P,  P>, D2 }
	cylinder { <-P, -P, -P>, < P, -P, -P>, D2 }
	cylinder { <-P, -P,  P>, < P, -P,  P>, D2 }
	}
}

#declare Cage_Cubique = object
{
union	{
	object { Coins_Cube 			}
	object { Barres_Cube 			}
	}
texture { Bronze_Texture }
}

/*    ============================================================    */
/*
 *	13 décembre 2022, neuve heure du soir.
 */

#declare Une_Gravity_Face = object
{
#local DDD =  Sz_cube - 0.06;
box { <-DDD, 0, -DDD>, <DDD, 0.02, DDD> }

#declare IMNUM = mod(clock, 2000);
#declare INAME = concat("frames/colmap/", str(IMNUM, -5, 0), ".pnm");
#debug concat("\n    cubes.inc: picz = ", INAME, "\n\n")

texture {
	pigment	{
	 	// image_map { png "WS/mire1024.png" }
	 	image_map { ppm INAME }
	        rotate x*90
	        translate <-0.5, 0, -0.5>
		scale DDD*2				// ???
		}
	finish { phong PHONG  specular SPECULAR emission 0.30 }
	}
}

#declare Gravity_Cube = object
{
#local EEE = Sz_cube;
union	{
	object { Une_Gravity_Face translate  y*EEE }
	object { Une_Gravity_Face translate -y*EEE }

	object { Une_Gravity_Face rotate z*90 translate  x*EEE }
	object { Une_Gravity_Face rotate z*90 translate -x*EEE }

	object { Une_Gravity_Face rotate x*90 translate  z*EEE }
	object { Une_Gravity_Face rotate x*90 translate -z*EEE }

	object { Cage_Cubique }      /* decorations.inc */
	}
rotate x*45
rotate z*45
rotate -y*(clock*2.72)
}

/*    ============================================================    */
//
// nouveau valensole 11 juillet 2021

#declare Miroir_Cube = object
{
#local Dm = Sz_cube * 0.94;
box { <-Dm, -0.003, -Dm>, <Dm, 0.003, Dm> }
texture  {
	pigment { color Gray70 }
	finish { ambient 0 diffuse 0 reflection 0.96 }
	}
}

#declare Les_Miroirs_du_Cube = object
{
union	{
	object { Miroir_Cube			translate -Sz_cube*y	}
	object { Miroir_Cube			translate  Sz_cube*y	}
	object { Miroir_Cube	rotate x*90	translate -Sz_cube*z	}
	object { Miroir_Cube	rotate x*90	translate  Sz_cube*z	}
	object { Miroir_Cube	rotate z*90	translate -Sz_cube*x	}
	object { Miroir_Cube	rotate z*90	translate  Sz_cube*x	}
	}
}

#declare PsychoCube = object
{
union	{
	object { Cage_Cubique 			}
	object { Les_Miroirs_du_Cube 		}
	}
rotate <45, 0, 45>
}

/*    ============================================================    */
/*
 *
 */
#declare D_CL = Sz_cube;

#local Decoupe_Cube_Lumiere_a = object
{
#local D3 = D_CL + 0.10;
#local E = 0.41;		/* ecart des trous sur la face */
#local Ra = 0.082;
#local Rb = 0.085;
union	{

	union {
	   #local Sc = 4.65;
	   cylinder { <-D3, 0, 0>, <D3, 0, 0> Ra scale <1, Sc, 1> }
	   cylinder { <-D3, 0, 0>, <D3, 0, 0> Ra scale <1, 1, Sc> }
	   rotate x*45
	   }

	cylinder { <-D3, -E, -E>, <D3, -E, -E>, 	Rb }
	cylinder { <-D3, -E,  E>, <D3, -E,  E>, 	Rb }
	cylinder { <-D3,  E, -E>,  <D3, E, -E>, 	Rb }
	cylinder { <-D3,  E,  E>,  <D3, E,  E>, 	Rb }

	cylinder { <-D3, -E,  0>, <D3, -E,  0>, 	Rb }
	cylinder { <-D3,  E,  0>, <D3,  E,  0>, 	Rb }
	cylinder { <-D3,  0, -E>, <D3,  0, -E>, 	Rb }
	cylinder { <-D3,  0,  E>, <D3,  0,  E>, 	Rb }
	}
}

#declare Corps_Cube_Lumiere = object
{
difference {
	box { <-D_CL, -D_CL, -D_CL>, < D_CL,  D_CL,  D_CL> }
	#local D2 = D_CL - 0.017;
	box { <-D2, -D2, -D2>, < D2,  D2,  D2> }

	object { Decoupe_Cube_Lumiere_a }
	object { Decoupe_Cube_Lumiere_a rotate z*90 }
	object { Decoupe_Cube_Lumiere_a rotate y*90 }
	}
texture {
	pigment { color Gray70 }
	normal { bumps 0.25 scale 0.11 }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Cube_Lumiere = object
{
union	{
	object { Cage_Cubique 			}
	object { Corps_Cube_Lumiere		}
// put the light HERE XXX
	#local Sz = 0.30 * Cos_01(NormClock);
	#local dx = Sz * sin(radians(clock));
	#local dy = Sz * sin(radians(clock*2));
	#local dz = Sz * cos(radians(clock*4));
	#local R  = 0.333 + (0.333 * sin(NormClock*133.333));
	#local G  = 0.500;
	#local B  = 0.333 + (0.333 * sin(NormClock*51.42));
	light_source {
		<dx, dy, dz>, color rgb <R, G, B>
		fade_distance	FADE_D
		fade_power	(FADE_P * 1.45)
		}
	}

rotate <45, 0, 45>
}


/*    ------------------------------------------------------    */

